import React from 'react';
import ReactDOM from 'react-dom';
import { arc } from 'd3';

const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;
const radius = 180;
const strokeWidth = 12;
const mouthRadius = 125;
const eyeWidth = 85;
const eyeHeight = 12;
const eyeUp = 140;
const rightEyeX = 70;
const rightEyeY = 65;
const noseRadius = 50;
const noseDown = 32;
const blushOffsetX = 110;
const blushOffsetY = 50;
const blushX = 45;
const blushY = 25;
const opacity=0.6;
const leftCapAngle = -150;
const rightCapAngle = -180-leftCapAngle-36;


const mouthArc = arc()
    .innerRadius(mouthRadius)
    .outerRadius(mouthRadius + strokeWidth)
    .startAngle(Math.PI * 1)
    .endAngle(Math.PI * 1.4)
    ;

const capArc = arc()
    .innerRadius(138)
    .outerRadius(0)
    .startAngle(Math.PI * - 0.3)
    .endAngle(Math.PI * - 0.5)
    ;


const App = () => (
      <svg width={width} height={height}>
      <g transform={`translate(${centerX}, ${centerY+25})`}>
        <path d={capArc()}  transform = {`translate(200 -240) rotate(${rightCapAngle})`} fill="RoyalBlue"/>
        <path d={capArc()}  transform = {`translate(-210 -230) rotate(${leftCapAngle})`} fill="MediumOrchid" />

        <circle
          r={radius}
          fill="AntiqueWhite"
          stroke="black"
          stroke-width={strokeWidth}
        />

        <rect
          x={-eyeUp}
          width={eyeWidth}
          height={eyeHeight}
          transform='rotate(45)'
        />
        
        <rect
          x={- eyeWidth/2 + eyeHeight/2}
          y={eyeUp - eyeWidth/2 - eyeHeight/2}
          width={eyeWidth}
          height={eyeHeight}
          transform='rotate(135)'
        /> 
          
       <circle
          r={noseRadius}
          cy={noseDown}
          fill="red"
          fill-opacity={opacity+0.1}
          stroke="red"
          stroke-width={6}
        />
        
      <ellipse
          rx="20"
          ry="10"
          fill="white"
          fill-opacity={opacity}
        />
        
        
      <ellipse
          cx={blushOffsetX}
          cy={blushOffsetY}
          rx={blushX}
          ry={blushY}
          fill="red"
          fill-opacity={opacity - 0.4}

        />
        
      <ellipse
          cx={-blushOffsetX}
          cy={blushOffsetY}
          rx={blushX}
          ry={blushY}
          fill="red"
          fill-opacity={opacity - 0.4}
        />
        
        
      <ellipse
          cx={rightEyeX}
          cy= {-rightEyeY}
          rx="26"
          ry="40"
          fill="white"
          fill-opacity={opacity}
          stroke="black"
          stroke-width={10}
          stroke-dasharray="10 5"
      />
        
      <ellipse
          cx={rightEyeX}
          cy={-rightEyeY}
          rx="10"
          ry="23"
      />


      <path d={mouthArc()} fill="white" stroke="black" stroke-width="5"  transform='rotate(-65)'/>
     


   </g>
  </svg>
);

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
